#include "okrogi.h"

int okrogi(int din)
{
  int x, y, a, b; // koordinate vhodne toke in sredia
  int tmp;        // leva stran enabe kronice
  char rgb, i;
  char color[5] = {0x03, 0xB4, 0x25, 0x18, 0xA0}; // matrika barv
  int dout;      // izhod

  a = 16;        // zaetna x koordinata prvega kolobarja
  x = (din >> 8) & 0xFF;  // dekodiranje vhoda din, format: 0x80 yy xx rgb
  y = (din >> 16) & 0xFF;

  rgb=0;
  loop0: for (i=0; i<5; i++) { // zanka za raunanje 5 kolobarjev
   if (i%2==0) b = 28;         // menjava y koordinat
   else b = 16;

   tmp = (x-a)*(x-a) + (y-b)*(y-b);

   // e se toka nahaja znotraj kolobarja (14 < r < 16), postavi rgb na color[i]
   if ((tmp < 16*16) && (tmp > 14*14)) rgb = color[i];

   a += 18;
  }

  // sestavi izhod
  if (rgb==0) dout = din;
  else dout = (din & 0xFFFFFF00) | rgb;

  return dout;
}
